from add_sys import *
from multiple_experiment_launcher import multiple_experiment
from iterator_exp import ExperimentIterator
from utils_experiment import VAEACIterator, create_name


if __name__ == '__main__' :
    args = get_default()
    args = get_default_local(args)
    
    args.args_trainer.monte_carlo_gradient_estimator = "PATHWISE"
    args.args_distribution_module.distribution_module = "DistributionWithTemperatureParameter"
    args.args_distribution_module.distribution = "RelaxedSubsetSampling_STE"
    args.args_selection.regularization = None
    args.args_selection.loss_regularization = None # L1, L2 

    
    origin_path = args.args_output.path
    args.args_trainer.complete_trainer = "SINGLE_LOSS"
    args.args_interpretable_module.interpretable_module = "COUPLED_SELECTION"
    args.args_classification.imputation = "ModuleImputation"
    
    path = missingDataTrainingModule.__path__[0]
    path_weight = os.path.join(path, "Prediction")
    path_weight = os.path.join(path_weight, "SupervizedLearningWithMissingData")
    path_weight = os.path.join(path_weight, "VAEACImputation")
    path_weight = os.path.join(path_weight, "vaeac")
    path_weight = os.path.join(path_weight, "celeba_model")
    vaeac_iterator = VAEACIterator(model_dir_list = path_weight)


    iterator = ExperimentIterator(iter_cste= False, iter_lambda=False, iter_rate=True)
    count = 0
    for index, dataset_name, dataset, loader in iterator.__iter__(args) :
        for folder in vaeac_iterator.__iter__(args, loader=loader,) :
            args_local = create_name(args, dataset_name, name_experiment, count)
            count = multiple_experiment(
                        count,
                        dataset,
                        loader,
                        complete_args=args_local,
                        name_modification = True)
